package processo;

import java.util.Iterator;
import java.util.List;

import emergenza.Area;
import emergenza.Edificio;
import _framework.Executor;

import gui.*;

public class GestioneArea implements Runnable 
{
	private Area area;
	private boolean eseguito=false;
	private List<Edificio> edifici;

	public GestioneArea(Area area) {
		this.area=area;
	}

	public synchronized void run() 
	{
		if (eseguito)
			return;
		eseguito=true;
		edifici=AttivitaIO.inserisciEdifici(area.getNome());
		RegistraInfoEdifici regInfo=new RegistraInfoEdifici(edifici,area);
		Executor.perform(regInfo);
		Iterator<Edificio> iter=edifici.iterator();
		while(iter.hasNext())
		{
			//Il successivo indirizzo da considerare per un edificio
			Edificio edif=iter.next();
			boolean agibile=AttivitaIO.leggiAgibilita(edif.getIndirizzo());
			Executor.perform(new AggiornaAgibilita(edif,agibile));
			List<RecordPersona> recQuest=AttivitaIO.leggiQuestionario(edif.getIndirizzo());
			Executor.perform(new AggiornaInfoEdifici(edif,recQuest));
		}
		AttivitaIO.mostraInfoSalienti(area);
	}

}
